#include "button.h"
#include "esc.h"
#include "key.h"
#include "handler.h"
#include <stdio.h>
#include <string.h>
#include <unistd.h>

cui
cui_button_new(cui parent, int x, int y, char *s)
{
	cui obj = cui_alloc(sizeof(struct cui_button));
	cui_button_init(obj, parent, x, y, s);
	return obj;
}

int
cui_button_hdr(cui obj, int evt, int val, void *prm)
{
	char *s;
	int attr;

	if(evt == CUI_EVT_KEY){
		if(val == CUI_KEY_ENTER){
			cui_handler_call(obj, obj->handler_list, CUI_EVT_DRAW, CUI_DRAW_ACTIVE);
			usleep(200*1000);
			cui_handler_call(obj, obj->handler_list, CUI_EVT_BUTTON, 0);
			cui_draw(obj);
			return TRUE;
		}
		return FALSE;
	}

	/* CUI_EVT_DRAW */
	s = cui_button_str_get(obj);

	attr = (val == CUI_DRAW_FOCUS) ? CUI_ESC_ULINE : CUI_ESC_NORMAL;
	cui_draw_str(obj, 0, 0, "(", attr);
	cui_draw_str(obj, 1+strlen(s), 0, ")", attr);

	attr = (val == CUI_DRAW_ACTIVE) ? CUI_ESC_REVERSE : attr;
	cui_draw_str(obj, 1, 0, s, attr);
	cui_esc_attr(CUI_ESC_NORMAL);
	return TRUE;
}

void
cui_button_init(cui obj, cui parent, int x, int y, char *s)
{
	cui_label_init(obj, parent, x, y, s);
	obj->w += 2;
	obj->flags |= CUI_FLG_CAN_FOCUS;
	cui_bind(obj, CUI_EVT_DRAW | CUI_EVT_KEY, cui_button_hdr, NULL);
}

char *
cui_button_str_get(cui obj)
{
	return cui_label_str_get(obj);
}

void
cui_button_str_set(cui obj, char *s)
{
	cui_label_str_set(obj, s);
}

/* EOF */
