#include <stdio.h>
#include "cui.h"
#include "handler.h"
#include "label.h"
#include "button.h"
#include "dialog.h"

int
my_hdr(cui obj, int evt, int val, void *prm)
{
	cui_simple_dialog p = (cui_simple_dialog)prm;
	cui_label_str_set(p->label, "Realy ?");
	cui_button_str_set(p->btn1, "Yes");
	cui_button_str_set(p->btn2, "No");
	cui_unbind(obj, CUI_EVT_BUTTON, my_hdr);
	return TRUE;
}

int
my_hdr2(cui obj, int evt, int val, void *prm)
{
	cui dlg = (cui)prm;
	if(cui_is_visible(dlg)) cui_hide(dlg);
	else cui_show(dlg);
	cui_button_str_set(obj, cui_is_visible(dlg) ? "Hide Dialog" : "Show Dialog");
	return TRUE;
}

int
main()
{
	cui base = cui_base_new(NULL, 0, 0, 40, 20);
	cui btn = cui_button_new(base, 2, 1, "Show Dialog");
	cui dlg = cui_simple_dialog_new(base, 2, 2, "Are you sure ?", "OK", "Cancel");
	cui_simple_dialog p = (cui_simple_dialog)dlg;

	dlg->flags |= CUI_FLG_HIDE;
	cui_bind(btn, CUI_EVT_BUTTON, my_hdr2, p);
	cui_bind(p->btn1, CUI_EVT_BUTTON, my_hdr, p);

	cui_main(base);
	printf("result %s\n", p->btn_result);
	cui_free(base);
	return 0;
}

/* EOF */
